routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\Menu\Berita\UpdateBerita\UpdateBeritaController;
use App\Http\Controllers\Menu\Berita\UpdateKategori\UpdateKategoriController;
use App\Http\Controllers\Menu\Dashboard\DashboardController;
use App\Http\Controllers\Menu\Dokumen\DokumenManagementController;
use App\Http\Controllers\Menu\Dokumen\DokumenManagementKategoriController;
use App\Http\Controllers\Menu\Dokumen\DokumenViewController;
use App\Http\Controllers\Menu\Survey\SurveyController;
use App\Http\Controllers\Menu\Survey\SurveyManagemenController;
use App\Http\Controllers\Menu\UserManagement\ListUser\ListUserController;
use App\Http\Controllers\Menu\UserManagement\UserPermission\UserPermissionController;
use App\Http\Controllers\Menu\UserManagement\UserRole\UserRoleController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use RealRashid\SweetAlert\Facades\Alert;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/


/*
|--------------------------------------------------------------------------
| PROFILE
|--------------------------------------------------------------------------
*/
Route::get('/sejarah', function () {
    return view('home.homepage.profile.sejarah.index');
})->name('home.sejarah');
Route::get('/visi-misi', function () {
    return view('home.homepage.profile.visimisi.index');
})->name('home.visimisi');
Route::get('/organisasi', function () {
    return view('home.homepage.profile.struktur.index');
})->name('home.organisasi');
Route::get('/logo', function () {
    return view('home.homepage.profile.logo.index');
})->name('home.logo');


/*
|--------------------------------------------------------------------------
| JAMINAN MUTU
|--------------------------------------------------------------------------
*/
Route::get('/audit', function () {
    return view('home.homepage.jaminanmutu.audit.index');
})->name('home.audit');


/*
|--------------------------------------------------------------------------
| LAYANAN
|--------------------------------------------------------------------------
*/
Route::get('/pembinaan-kearsipan', function () {
    return view('home.homepage.layanan.pembinaanarsip.index');
})->name('home.pembinaan.kearsipan');
Route::get('/pengelolaan-kearsipan-statis', function () {
    return view('home.homepage.layanan.pengelolaanarsipstatis.index');
})->name('home.pengelolaan.kearsipan.statis');
Route::get('/pengelolaan-akuisisi-arsip', function () {
    return view('home.homepage.layanan.akuisisi.index');
})->name('home.pengelolaan.akuisisi.arsip');
Route::get('/pelayanan-peminjaman-arsip', function () {
    return view('home.homepage.layanan.peminjamanarsip.index');
})->name('home.pelayanan.peminjaman.arsip');
Route::get('/alihmedia-arsip', function () {
    return view('home.homepage.layanan.alihmedia.index');
})->name('home.alihmedia.arsip');
Route::get('/penyelamatan-arsip', function () {
    return view('home.homepage.layanan.perbaikanpelestarian.index');
})->name('home.penyelamatan.arsip');
Route::get('/pemusnahan-arsip', function () {
    return view('home.homepage.layanan.pemusnahan.index');
})->name('home.pemusnahan.arsip');
Route::get('/studi-banding', function () {
    return view('home.homepage.layanan.kunjungan.index');
})->name('home.stiudibanding.arsip');
Route::resource('survey', SurveyController::class);


/*
    |--------------------------------------------------------------------------
    | PRIVATE MENU PER ROLE
    | TINGKATAN DIMULAI PALING ATAS
    |--------------------------------------------------------------------------
*/
//AUTHENTICATION
Route::resource('/', HomeController::class);
Route::get('/news/{home}', [HomeController::class, 'show'])->name('home.show');

Alert::success('Selamat Datang di Arsip UB Apps!');
Auth::routes();

//Super Admin
Route::prefix('')->middleware(['auth', 'role:Super Admin'])->group(function () {
    //
});

//Admin Head Office,
Route::prefix('')->middleware(['auth', 'role:Super Admin, Admin Head Office'])->group(function () {
    //
});

//Admin Company

Route::prefix('')->middleware(['auth', 'role:Super Admin, Admin Head Office, Admin Company'])->group(function () {
    /*
    |--------------------------------------------------------------------------
    | User Management Resource Routes
    |--------------------------------------------------------------------------
    */
    //User List
    Route::post('user-list/company', [ListUserController::class, 'create_company'])->name('create-company');
    Route::get('user-list/list', [ListUserController::class, 'index_datatable'])->name('index-user');
    Route::resource('user-list', ListUserController::class);
    //User Role
    Route::resource('user-role', UserRoleController::class);
    //User Permission
    Route::resource('user-permission', UserPermissionController::class);
    /*
    |--------------------------------------------------------------------------
    | Next Resource Routes
    |--------------------------------------------------------------------------
    */
});

//User (Menu '/' dibuat di tingkatan paling rendah, karena default access ke /)
Route::prefix('')->middleware(['auth', 'role:Super Admin, Admin Head Office, Admin Company, User'])->group(function () {
    /*
    |--------------------------------------------------------------------------
    | Dashboard Resource Routes
    |--------------------------------------------------------------------------
    */
    Route::resource('dashboard', DashboardController::class);
    /*
    |--------------------------------------------------------------------------
    | File Resource Kategori
    |--------------------------------------------------------------------------
    */
    Route::resource('kategori-berita', UpdateKategoriController::class);
    /*
    |--------------------------------------------------------------------------
    | File Resource Berita
    |--------------------------------------------------------------------------
    */
    Route::get('berita/list', [UpdateBeritaController::class, 'index_datatable'])->name('index-berita');
    Route::resource('berita', UpdateBeritaController::class);
    /*
    |--------------------------------------------------------------------------
    | File Resource Management Dokumen
    |--------------------------------------------------------------------------
    */
    Route::resource('dokumen-management', DokumenManagementController::class);
    /*
    |--------------------------------------------------------------------------
    | File Resource Kategori Management Dokumen
    |--------------------------------------------------------------------------
    */
    Route::resource('kategori-dokumen-management', DokumenManagementKategoriController::class);
    /*
    |--------------------------------------------------------------------------
    | Survey
    |--------------------------------------------------------------------------
    */
    Route::resource('survey-management', SurveyManagemenController::class);
});

/*
|--------------------------------------------------------------------------
| File Resource Dokumen
|--------------------------------------------------------------------------
*/
Route::resource('dokumen', DokumenViewController::class);

app/Http/Controllers/Menu/UserManagement/ListUser/ListUserController.php
<?php

namespace App\Http\Controllers\Menu\UserManagement\ListUser;

use App\Http\Controllers\Controller;
use App\Models\Role;
use Illuminate\Support\Str;
use App\Models\RoleUser;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Exception;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Validator;
use RealRashid\SweetAlert\Facades\Alert;
use Illuminate\Validation\Rule;

class ListUserController extends Controller
{
    private $user;
    private $role;
    private $roleuser;
    public function __construct()
    {
        $this->middleware('auth');
        $this->user = new User();
        $this->role = new Role();
        $this->roleuser = new RoleUser();
    }
    /**
     * Display a listing of the resource.
     */
    public function index()
    {

        $role = $this->role::get();
        return view('menu.usermanagement.userlist.index',compact('role'));
    }
    /**
     * Display a listing of the resource.
     */
    public function index_datatable(Request $request)
    {
        //Datatable Manual : Create by Ananda & Doc. Vuexy
        $columns = [
            'id',
            'name',
            'email',
        ];
        $totalData = User::count();
        $search = $request->input('search.value');
        $query = $this->user::with('roles')->select('users.*');
        if (!empty($search)) {
            $query->where(function ($q) use ($columns, $search) {
                foreach ($columns as $column) {
                    if (strpos($column, '.') !== false) {
                        // Kolom relasional
                        [$relation, $column] = explode('.', $column);
                        $q->orWhereHas($relation, function ($query) use ($column, $search) {
                            $query->where($column, 'LIKE', "%$search%");
                        });
                    } else {
                        // Kolom non-relasional
                        $q->orWhere($column, 'LIKE', "%$search%");
                    }
                }
            });
        }
        $totalFiltered = $query->count();
        $start = $request->input('start', 0);
        $length = $request->input('length', 10);
        $order = $columns[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir', 'asc');
        $query->offset($start)->limit($length)->orderBy($order, $dir);
        $data = [];
        foreach ($query->get() as $user) {
            $roles = $user->roles;
            $roleName = $roles->isNotEmpty() ? $roles->first()->name : '-';
            $roleChoice = $roles->isNotEmpty() ? $roles->first()->id : '-';
            $data[] = [
                'id' => $user->id,
                'name' => $user->name,
                'email' => $user->email,
                'roles' =>  $roleName,
                'actions' => '<button class="btn btn-primary btn-edit" data-bs-target="#editUserModal" data-bs-toggle="modal" data-id="'.$user->id.'" data-name="'.$user->name.'" data-email="'.$user->email.'" data-roles="'.$roleChoice.'" ">Edit</button>
                            <button class="btn btn-danger btn-delete" data-id="'.$user->id.'">Delete</button>',
            ];
        }
        $response = [
            'draw' => intval($request->input('draw', 1)),
            'recordsTotal' => $totalData,
            'recordsFiltered' => $totalFiltered,
            'data' => $data,
        ];
        return response()->json($response);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {

    }
    /**
     * Show the form for creating a new company resource.
     */
    public function create_company(Request $request)
    {
        $validator = Validator::make($request->all(), [
            //
        ]);
        if ($validator->fails()) {
            //Validator
            Alert::error('Error','Data Tidak Lengkap!');
            return Redirect()->back();
        } else {
            try {
                DB::transaction(function() use ($request) {
                    $data = new $this->company();
                    $data->company_name = $request->CompanyName;
                    $data->company_code = $request->CompanyCode;
                    $data->save();
                });
                Alert::success('Success', 'Company Saved!');
                return Redirect()->route('user-list.index');
            } catch (Exception $e) {
                throw $e;
                DB::rollback();
                Alert::error('Error', $e->getMessage());
                return Redirect()->back();
            }
        }
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string', 'max:255', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
            'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
            'password' => ['required', 'string', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
            'role_id' => ['required', 'string', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
        ]);
        if ($validator->fails()) {
            //Validator
            Alert::warning('Input Belum Lengkap!',  $validator->errors()->all());
            return Redirect()->back();
        } else {
            try {
                DB::transaction(function() use ($request) {
                    //Create User
                    $data = new $this->user();
                    $data->name = $request->name;
                    $data->email = $request->email;
                    $data->active = 1;
                    $data->verify_key = Str::random(64);
                    $data->password = Hash::make($request->password);
                    $data->save();
                    //Assign Role id dari User
                    $role = new $this->roleuser();
                    $role->user_id = $data->id;
                    $role->role_id = $request->role_id;
                    $role->save();
                });
                Alert::success('Success', 'User Saved!');
                return Redirect()->route('user-list.index');
            } catch (Exception $e) {
                throw $e;
                DB::rollback();
                Alert::error('Error', $e->getMessage());
                return Redirect()->back();
            }
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(Request $request, string $id)
    {
       //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        $validator = Validator::make($request->all(), [
            'user_id' => ['required', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
            'name' => ['required', 'string', 'max:255', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
            'email' => ['required', 'string', 'email', 'max:255', Rule::unique('users')->ignore($request->user_id, 'id'),],
            'role_id' => ['required', 'string', 'regex:/^[a-zA-Z0-9\s\-\.,]+$/'],
        ]);
        if ($validator->fails()) {
            //Validator
            Alert::warning('Input Belum Lengkap!',  $validator->errors()->all());
            return Redirect()->back();
        } else {
            try {
                $user = $this->user::find($request->user_id);
                if (!empty($user)) {
                    // User exists
                    DB::transaction(function () use ($request, $user) {
                        // Update User
                        $user->name = $request->name;
                        $user->email = $request->email;
                        $user->password = Hash::make($request->password);
                        $user->save();
                        // Update Role
                        $user->roles()->sync([$request->role_id]);
                    });
                    Alert::success('Success', 'User Updated!');
                    return Redirect()->route('user-list.index');
                } else {
                    Alert::success('Warning', 'User Not Found!');
                    return Redirect()->route('user-list.index');
                }
            } catch (Exception $e) {
                throw $e;
                DB::rollback();
                Alert::error('Error', $e->getMessage());
                return Redirect()->back();
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        if ($id == null) {
            return redirect()->back()->with('error', 'Id Tidak Tersedia');
        } else {
            try {
                DB::transaction(function() use ($id) {
                    $data = $this->user::find($id);
                    $data->delete();
                });
                return response()->json(['success' => 'Data Deleted!'], 200);
            } catch (Exception $e) {
                throw $e;
                DB::rollback();
                return response()->json(['error' => $e->getMessage()], 500);
            }
        }
    }
}

resources/views/menu/usermanagement/userrole/index.blade.php
@extends('main.index')
{{-- Head --}}
@push('style')
    {{--  --}}
@endpush
@push('javascript')
    <script src="{{ asset('assets/js/app-access-roles.js') }}"></script>
    <script src="{{ asset('assets/js/modal-add-role.js') }}"></script>
    <script type="text/javascript">
        let csrf = '{{ csrf_token() }}';
        $(document).ready(function() {
            // Ketika checkbox all diubah statusnya
            $(document).on('change', '#selectAll', function() {
                // Ambil status checked/unchecked dari checkbox all
                let isChecked = $(this).is(':checked');
                // Ubah status checked/unchecked pada semua checkbox dengan class "checkbox"
                $('.form-check-input').prop('checked', isChecked);
            });

            // Ketika salah satu checkbox dengan class "checkbox" diubah statusnya
            $(document).on('change', '.form-check-input', function() {
                // Periksa jumlah checkbox yang sudah tercentang
                let checkedCount = $('.form-check-input:checked').length;
                let totalCount = $('.form-check-input').length;

                // Jika semua checkbox tercentang, centang juga checkbox all
                $('#selectAll').prop('checked', checkedCount === totalCount);
            });
        });
    </script>
@endpush
{{-- Mark Sidebar --}}
@section('usermanagement.open', 'open')
@section('usermanagement.active', 'active')
{{-- Mark Side Menu Sidebar --}}
@section('userrole.active', 'active')
{{-- --------------- --}}
@section('content')
    <div class="container-xxl flex-grow-1 container-p-y">
        <h4 class="fw-semibold mb-4">User All List</h4>
        <p class="mb-4">
            Company yang terdaftar pada MerdekaBaseApps <br />
            Penambahan Company untuk grouping user berdasarkan company.
        </p>
        <!-- Role cards -->
        <div class="row g-4">
            @foreach ($role as $menurole)
                <div class="col-xl-4 col-lg-6 col-md-6">
                    <div class="card">
                        <div class="card-body">
                            <div class="d-flex justify-content-between">
                                <h6 class="fw-normal mb-2">Total
                                    {{ $menurole->users->count() }}
                                    users</h6>
                                <ul class="list-unstyled d-flex align-items-center avatar-group mb-0">
                                    @for($i = 1; $i <= $menurole->users->count(); $i++)
                                    <li data-bs-toggle="tooltip" data-popup="tooltip-custom" data-bs-placement="top"
                                        title="Vinnie Mostowy" class="avatar avatar-sm pull-up">
                                        <img class="rounded-circle" src="{{ asset('/assets/img/avatars/brone.png') }}" alt="Avatar" />
                                    </li>
                                    @endfor
                                </ul>
                            </div>
                            <div class="d-flex justify-content-between align-items-end mt-1">
                                <div class="role-heading">
                                    <h4 class="mb-1">{{ $menurole->name }}</h4>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
            <div class="col-xl-4 col-lg-6 col-md-6">
                <div class="card h-100">
                    <div class="row h-100">
                        <div class="col-sm-5">
                            <div class="d-flex align-items-end h-100 justify-content-center mt-sm-0 mt-3">
                                <img src="../../assets/img/illustrations/auth-verify-email-illustration-dark.png"
                                    class="img-fluid mt-sm-4 mt-md-0" alt="add-new-roles" width="83" />
                            </div>
                        </div>
                        <div class="col-sm-7">
                            <div class="card-body text-sm-end text-center ps-sm-0">
                                <button data-bs-target="#addRoleModal" data-bs-toggle="modal"
                                    class="btn btn-primary mb-2 text-nowrap add-new-role">
                                    Tambah Role
                                </button>
                                <p class="mb-0 mt-1">Tambah Role untuk Role user</p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-12">
                <!-- Role Table -->
                <div class="card">
                    <div class="card-datatable table-responsive">
                        <table class="datatables-users table border-top">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th>id</th>
                                    <th>Role Name</th>
                                    <th>Total User</th>
                                    {{-- <th>Actions</th> --}}
                                    {{--
                                        action diserahkan ke masing-masing programmer berdasarkan kebutuhan pengembangan aplikasi
                                        --}}
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($role as $detilrole)
                                    <tr>
                                        <td></td>
                                        <td>{{ $detilrole->id }}</td>
                                        <td>{{ $detilrole->name }}</td>
                                        <td>{{ $detilrole->users->count() }}</td>
                                        {{-- <td></td> --}}
                                        {{--
                                        Button action diserahkan ke masing-masing programmer berdasarkan kebutuhan pengembangan aplikasi
                                        --}}
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
                <!--/ Role Table -->
            </div>
        </div>
        <!--/ Role cards -->
        <!-- Add Role Modal -->
        <div class="modal fade" id="addRoleModal" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog modal-lg modal-dialog-centered modal-add-new-role">
                <div class="modal-content p-3 p-md-5">
                    <button type="button" class="btn-close btn-pinned" data-bs-dismiss="modal" aria-label="Close"></button>
                    <div class="modal-body">
                        <div class="text-center mb-4">
                            <h3 class="role-title mb-2">Add New Role</h3>
                            <p class="text-muted">Set role permissions</p>
                        </div>
                        <!-- Add role form -->

                        <form id="addRoleForm" class="row g-3" action="{{ route('user-role.store') }}" method="POST">
                            @csrf
                            <div class="col-12 mb-4">
                                <label class="form-label" for="modalRoleName">Role Name</label>
                                <input type="text" id="modalRoleName" name="rolename" class="form-control"
                                    placeholder="Enter a role name" tabindex="-1" />
                            </div>
                            <div class="col-12">
                                <h5>Role Permissions</h5>
                                <!-- Permission table -->
                                <div class="table-responsive">
                                    <table class="table table-flush-spacing">
                                        <tbody>
                                            <tr>
                                                <td class="text-nowrap fw-semibold">
                                                    All Access Sub Menu
                                                    <i class="ti ti-info-circle" data-bs-toggle="tooltip"
                                                        data-bs-placement="top"
                                                        title="Allows a full access to the system"></i>
                                                </td>
                                                <td>
                                                    <div class="form-check">
                                                        <input class="form-check-input" type="checkbox" id="selectAll" />
                                                        <label class="form-check-label" for="selectAll"> Select All
                                                        </label>
                                                    </div>
                                                </td>
                                            </tr>
                                            @foreach ($menu as $key => $sub)
                                                <tr>
                                                    <td class="text-nowrap fw-semibold">{{ $sub->title }}</td>
                                                    <td>
                                                        <div class="d-flex">
                                                            <div class="form-check me-3 me-lg-5">
                                                                <label class="form-check-label"
                                                                    for="userManagementRead{{ $key }}"> Allow
                                                                </label>
                                                                <input class="form-check-input" name="permissions[]"
                                                                    type="checkbox"
                                                                    id="userManagementRead{{ $key }}"
                                                                    value="{{ $sub->id }}" />
                                                            </div>
                                                        </div>
                                                    </td>
                                                </tr>
                                            @endforeach

                                        </tbody>
                                    </table>
                                </div>
                                <!-- Permission table -->
                            </div>
                            <div class="col-12 text-center mt-4">
                                <button type="submit" class="btn btn-primary me-sm-3 me-1">Submit</button>
                                <button type="reset" class="btn btn-label-secondary" data-bs-dismiss="modal"
                                    aria-label="Close">
                                    Cancel
                                </button>
                            </div>
                        </form>
                        <!--/ Add role form -->
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection